<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Authentication API Dashboard</title>

    <!-- Custom fonts for this template-->
    <link href="/vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link
        href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
        rel="stylesheet">

    <!-- Custom styles for this template-->
    <link href="/css/sb-admin-2.min.css" rel="stylesheet">

</head>

<body id="page-top">

    <!-- Page Wrapper -->
    <div id="wrapper">

        <%- include('./partials/navbar'); %>

        <!-- Content Wrapper -->
        <div id="content-wrapper" class="d-flex flex-column">

            <!-- Main Content -->
            <div id="content">

                <%- include('./partials/topbar'); %>

                <!-- Begin Page Content -->
                <div class="container-fluid">

                    <!-- Page Heading -->
                    <div class="d-sm-flex align-items-center justify-content-between mb-4">
                        <h1 class="h3 mb-0 text-gray-800">Dashboard</h1>
                        <button id="createApplication" class="d-none d-sm-inline-block btn btn-sm btn-primary shadow-sm"><i
                                class="fas fa-upload fa-sm text-white-50"></i> Create Application</button>
                    </div>

                    <!-- Content Row -->
                    <div class="row">

                        <!-- Applications -->
                        <div class="col-xl-6 col-md-6 mb-4">
                            <div class="card border-left-primary shadow h-100 py-2">
                                <div class="card-body">
                                    <div class="row no-gutters align-items-center">
                                        <div class="col mr-2">
                                            <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                                Channel Sites</div>
                                            <div class="h5 mb-0 font-weight-bold text-gray-800"><%= applications.length %></div>
                                        </div>
                                        <div class="col-auto">
                                            <i class="fas fa-building fa-2x text-gray-300"></i>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <!-- Users Card -->
                        <div class="col-xl-6 col-md-6 mb-4">
                            <div class="card border-left-success shadow h-100 py-2">
                                <div class="card-body">
                                    <div class="row no-gutters align-items-center">
                                        <div class="col mr-2">
                                            <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                                                Users</div>
                                            <div class="h5 mb-0 font-weight-bold text-gray-800"></div>
                                        </div>
                                        <div class="col-auto">
                                            <i class="fas fa-user fa-2x text-gray-300"></i>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>

                    <!-- Content Row -->

                   

                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Applications</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                                    <thead>
                                        <tr>
                                            <th>Name</th>
                                            <th>Client ID</th>
                                            <!-- <th>Client Secret</th> -->
                                            <th>Channel Site</th>
                                            <th>Grant Types</th>
                                            <th>Apps</th>
                                            <th>Edit</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <% applications.forEach(function(application){ %>
                                            <tr class="applicationRow">
                                                <td id="applicationName"><%= application.name %></td>
                                                <td id="applicationClientId" data-secret="<%= application.clientSecret %>"><%= application.clientId %></td>
                                                <!-- <td id="applicationClientSecret"><%= application.clientSecret %></td> -->
                                                <td id="applicationChannelSiteId"><%= application.channelSiteId %></td>
                                                
                                                <td id="applicationGrantType"><%= application.grantType != null ? application.grantType.join(', ') : application.grantType %></td>
                                                <td id="applicationRoles"><%= application.role != null && typeof application.role != "string" ? application.role.join(', ') : application.role %></td>
                                                <td class="btn btn-primary application-edit">Edit</td>
                                            </tr>
                                        <% }) %>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->

            <!-- Footer -->
            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Authentication Dashboard</span>
                    </div>
                </div>
            </footer>
            <!-- End of Footer -->

        </div>
        <!-- End of Content Wrapper -->

    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
        <i class="fas fa-angle-up"></i>
    </a>

    <!-- Logout Modal-->
    <%- include('./partials/logoutmodal'); %>

    <!-- Application Modal-->
    <div class="modal fade" id="applicationModal" tabindex="-1" role="dialog" aria-labelledby="applicationModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="applicationModalLabel">Create/Update an Application</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form class="application" method="post" action="/admin/application">
                        <div class="form-group" id="applicationForm">
                            <input type="text" class="form-control" id="inputName" placeholder="Name" name="name">
                        </div>
                        <div class="form-group" id="applicationForm">
                            <input type="text" class="form-control" id="inputClientId" placeholder="Client ID" name="clientId" readonly="readonly">
                        </div>
                        <div class="form-group" id="applicationForm">
                            <input type="text" class="form-control" id="inputClientSecret" placeholder="Client Secret" name="clientSecret" readonly="readonly">
                        </div>
                        <div class="form-group" id="applicationForm">
                            <input type="text" class="form-control" id="inputChannelSiteId" placeholder="ChannelSiteId" name="channelSiteId">
                        </div>
                        <div class="form-group" id="applicationForm">
                            <select class="select2 form-control" multiple="multiple" id="inputGrantType" placeholder="Grant Type" name="grantType" style="width:100%">
                                <option value="client_credentials">client_credentials</option>
                                <option value="user_credentials">user_credentials</option>
                                <option value="code">code</option>
                            </select>
                        </div>
                        <div class="form-group" id="applicationForm">
                            <select class="select2 form-control" multiple="multiple" id="inputRoles" placeholder="Roles" name="role" style="width:100%">
                                <option value="partner">partner</option>
                                <option value="internal">internal</option>
                                <option value="seek">seek</option>
                                <option value="job">job</option>
                                <option value="candidate">candidate</option>
                                <option value="application">application</option>
                            </select>
                        </div>
                        <button class="btn btn-primary btn-application btn-block" id="applicationSubmit">
                            Save changes
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <!-- Bootstrap core JavaScript-->
    <script src="/vendor/jquery/jquery.min.js"></script>
    <script src="/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>

    <!-- Core plugin JavaScript-->
    <script src="/vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Custom scripts for all pages-->
    <script src="/js/sb-admin-2.min.js"></script>

    <!-- Page level plugins -->
    <script src="/vendor/chart.js/Chart.min.js"></script>

    <!-- Page level plugins -->
    <script src="/vendor/datatables/jquery.dataTables.min.js"></script>
    <script src="/vendor/datatables/dataTables.bootstrap4.min.js"></script>

    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>

    <!-- Page level custom scripts -->
    <!-- <script src="js/demo/datatables-demo.js"></script> -->

    <script>

        $(document).ready(function() {
            $('#dataTable').DataTable();
            $('.select2').select2({
                width: 'resolve' // need to override the changed default
            });
        });

        $(".application-edit").click(function(){
            var parent = $(this).parent();
            console.log(parent)
            $("#inputName").val(parent.find("#applicationName").text())
            $("#inputClientId").val(parent.find("#applicationClientId").text())
            $("#inputClientSecret").val(parent.find("#applicationClientId").attr("data-secret"))
            //$("#inputClientSecret").val(parent.find("#applicationClientSecret").text())
            $("#inputChannelSiteId").val(parent.find("#applicationChannelSiteId").text())

            var grantType = parent.find("#applicationGrantType").text().replace(/\s+/g, '').split(',')   
            $("#inputGrantType").val(grantType)
            $('#inputGrantType').trigger('change')

            var roles = parent.find("#applicationRoles").text().replace(/\s+/g, '').split(',')   
            $("#inputRoles").val(roles)
            $('#inputRoles').trigger('change')
            
            $("#applicationModal").modal('show');
        })

        $("#createApplication").click(function(){
            var parent = $(this)
            $("#inputName").val(null)
            $("#inputClientId").val(null)
            $("#inputClientSecret").val(null)
            $("#inputChannelSiteId").val(null)
            $("#inputGrantType").val(null)
            $('#inputGrantType').trigger('change')
            $("#inputRoles").val(null)
            $('#inputRoles').trigger('change')
            $("#applicationModal").modal('show');
        })
    </script>

</body>

</html>